Attribute VB_Name = "Bmp2Ico_bas"
'----------------------------------------------------------------------------------
'Mdulo Bmp2Ico.bas
'
'From: Morcillo, Eduardo A. (E-mail) <edanmo@geocities.com>
'Date: domingo, 10 de enero de 1999 00:57
'
'Te envio un modulo con dos funciones que creo que son utiles.
'La primera es para crear objetos StdPicture a partir de handles de iconos,
'bitmaps o metafiles.
'La segunda crea iconos (en objetos StdPicture) a partir de bitmaps en
'objetos StdPicture.
'El codigo esta bastante comentado. La primera funcion la he sacado del
'Knowledge Base de Microsoft y la segunda esta hecha 100% por mi.
'
'NOTA:
' Necesita una referencia a: STDOLE2.TLB (OLE Automation / Automatizacin OLE)
'----------------------------------------------------------------------------------
Option Explicit

Type PICTDESC
    cbSizeOfStruct As Long
    picType As Long
    hgdiObj As Long
    hPalOrXYExt As Long
End Type

Type IID
    Data1 As Long
    Data2 As Integer
    Data3 As Integer
    Data4(0 To 7) As Byte
End Type

Declare Sub OleCreatePictureIndirect Lib "oleaut32.dll" (lpPictDesc As PICTDESC, riid As IID, ByVal fOwn As Boolean, lplpvObj As Object)
    
Public Type ICONINFO
    fIcon As Long
    xHotspot As Long
    yHotspot As Long
    hbmMask As Long
    hbmColor As Long
End Type

Public Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type

Declare Function DestroyIcon Lib "user32" (ByVal hIcon As Long) As Long
Declare Function CreateIconIndirect Lib "user32" (piconinfo As ICONINFO) As Long
Declare Function CreateBitmap Lib "gdi32" (ByVal nWidth As Long, ByVal nHeight As Long, ByVal nPlanes As Long, ByVal nBitCount As Long, lpBits As Any) As Long
Declare Function SetStretchBltMode Lib "gdi32" (ByVal hDC As Long, ByVal nStretchMode As Long) As Long
Declare Function StretchBlt Lib "gdi32" (ByVal hDC As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal nSrcWidth As Long, ByVal nSrcHeight As Long, ByVal dwRop As Long) As Long
Declare Function SelectObject Lib "gdi32" (ByVal hDC As Long, ByVal hObject As Long) As Long
Declare Function CreateCompatibleBitmap Lib "gdi32" (ByVal hDC As Long, ByVal nWidth As Long, ByVal nHeight As Long) As Long
Declare Function CreateCompatibleDC Lib "gdi32" (ByVal hDC As Long) As Long
Declare Function FillRect Lib "user32" (ByVal hDC As Long, lpRect As RECT, ByVal hBrush As Long) As Long
Declare Function CreateSolidBrush Lib "gdi32" (ByVal crColor As Long) As Long
Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Declare Function DeleteDC Lib "gdi32" (ByVal hDC As Long) As Long
Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
Declare Function GetWindowDC Lib "user32" (ByVal hWnd As Long) As Long
Declare Function ReleaseDC Lib "user32" (ByVal hWnd As Long, ByVal hDC As Long) As Long
Declare Function SelectPalette Lib "gdi32" (ByVal hDC As Long, ByVal hPalette As Long, ByVal bForceBackground As Long) As Long
Declare Function RealizePalette Lib "gdi32" (ByVal hDC As Long) As Long

Public Const HALFTONE As Long = 4

'-------------------------------------------------------------------------
' BMPToIcon: Crea un icono a partir de un bitmap
'
' Parametros:
'
'   Bitmap: El objeto Picture desde en cual se encuentra
'           el bitmap
'   IconCX: El ancho deseado del icono creado. Si no se especifica
'           es 32
'   IconCY: Igual que IconCX pero es el alto.
'
'-------------------------------------------------------------------------
Public Function BMPToIcon(ByVal Bitmap As IPicture, _
                          Optional ByVal IconCX As Long, _
                          Optional ByVal IconCY As Long) As StdPicture
Dim ScreenDC As Long, BitmapDC As Long, IconoDC As Long
Dim hBmp As Long, hBr As Long
Dim hIcn As Long, hIcnMask As Long
Dim OldPal As Long, II As ICONINFO
Dim R As RECT

    On Error Resume Next
        
    ' Si no se indica un tama_o de icono
    ' se crea uno de 32x32
    
    If IconCX = 0 Then IconCX = 32
    If IconCY = 0 Then IconCY = 32
    
    If Bitmap Is Nothing Then
        ' Si el bitmap es Nothing devuelvo
        ' Nothing como resultado de la funcion
        
        Set BMPToIcon = Nothing
        Exit Function
    
    ElseIf Bitmap.Handle = 0 Or Bitmap.Type = vbPicTypeEMetafile Or Bitmap.Type = vbPicTypeMetafile Then
        ' Si el objeto bitmap no contiene una imagen
        ' o es un wmf devuelvo un icono
        ' vacio
    
        ' Tomo el DC del escritorio (la pantalla)
        ScreenDC = GetWindowDC(0&)
    
        ' Creo un DC compatible con el del escritorio
        BitmapDC = CreateCompatibleDC(ScreenDC)
  
        ' Creo dos bitmaps para hacer el icono
        hBmp = CreateCompatibleBitmap(ScreenDC, IconCX, IconCY)
        hIcnMask = CreateBitmap(IconCX, IconCY, 1, 1, ByVal 0&)
    
        R.Right = IconCX
        R.Bottom = IconCY
    
        ' Seleciono el bitmap para mascara y lo lleno
        ' con blanco (transparente)
        SelectObject BitmapDC, hIcnMask
        hBr = CreateSolidBrush(&HFFFFFF)
        FillRect BitmapDC, R, hBr
        DeleteObject hBr
        SelectObject BitmapDC, 0&
    
        ' Seleciono el bitmap para el icono y lo lleno
        ' con el color de fondo de botones
        SelectObject BitmapDC, hBmp
        FillRect BitmapDC, R, 16&
        
        ' Libero los DC que ya no necesito
        DeleteDC BitmapDC
        ReleaseDC 0&, ScreenDC
    
    ElseIf Bitmap.Type = vbPicTypeIcon Then
        ' Si Bitmap es un icono
        ' lo devuelvo sin modificaciones
        
        Set BMPToIcon = Bitmap
        Exit Function
         
    Else
    
        ' Bitmap es un mapa de bits valido
        
        ' Tomo el DC del escritorio (la pantalla)
        ScreenDC = GetWindowDC(0&)
    
        ' Creo dos DC compatibles con el del escritorio
        BitmapDC = CreateCompatibleDC(ScreenDC)
        IconoDC = CreateCompatibleDC(ScreenDC)
          
        ' Creo dos bitmaps para hacer la mascara y el icono
        hIcnMask = CreateBitmap(IconCX, IconCY, 1, 1, ByVal 0&)
        hBmp = CreateCompatibleBitmap(ScreenDC, IconCX, IconCY)
        
        R.Right = IconCX
        R.Bottom = IconCY
    
        ' Seleciono el bitmap para mascara y lo lleno
        ' con negro (opaco)
        SelectObject IconoDC, hIcnMask
        hBr = CreateSolidBrush(&H0)
        FillRect IconoDC, R, hBr
        DeleteObject hBr
        SelectObject IconoDC, 0&
        
        ' Selecciono la paleta del bitmap para crear
        ' el icono con la misma paleta
        OldPal = SelectPalette(IconoDC, Bitmap.hPal, True)
        RealizePalette IconoDC
            
        ' Seteo el modo de Stretch a HALFTONE
        SetStretchBltMode IconoDC, HALFTONE
        
        ' Selecciono el bitmap de destino el
        ' el DC correspondiente
        SelectObject IconoDC, hBmp
        
        R.Left = Bitmap.Width / 26.46
        R.Top = Bitmap.Height / 26.46
        
        
        If Bitmap.CurDC = 0 Then
            ' Si el bitmap no esta seleccionado en
            ' ningun DC tengo que seleccionarlo
            ' para poder copiarlo.
        
            SelectObject BitmapDC, Bitmap.Handle
            
            ' Copio el bitmap original en el nuevo del icono
            ' Las medidas de Width y Height en el objeto Bitmap
            ' viene en HIMETRIS que son aprox. 26 pixels.
            Call StretchBlt(IconoDC, 0, 0, IconCX, IconCY, BitmapDC, 0, 0, R.Left, R.Top, vbSrcCopy)
            
            SelectObject BitmapDC, 0&
        Else
            ' El bitmap ya esta seleccionado
            ' en un DC
            
            Call StretchBlt(IconoDC, 0, 0, IconCX, IconCY, Bitmap.CurDC, 0, 0, R.Left, R.Top, vbSrcCopy)
        End If
         
        ' Libero los DC
        SelectPalette IconoDC, OldPal, True
        SelectObject IconoDC, 0&
        
        DeleteDC BitmapDC
        DeleteDC IconoDC
        ReleaseDC 0&, ScreenDC
    End If
    
    ' Creo el icono a partir de
    ' los bitmaps creados
    II.fIcon = True
    II.hbmColor = hBmp
    II.hbmMask = hIcnMask
    hIcn = CreateIconIndirect(II)
    
    ' Libero los bitmaps creados
    DeleteObject hBmp
    DeleteObject hIcnMask
    
    ' Creo un objeto IPictureDisp con
    ' el icono recien creado
    
    Set BMPToIcon = HandleToPicture(hIcn, vbPicTypeIcon, Bitmap.hPal)
     
    ' El handle del icono no debe ser
    ' borrado debido a que ahora pertenece
    ' al objeto que devuelve la funcion
     
End Function

'-------------------------------------------------------------------------
' HandleToPicture: Crea un objeto StdPicture a partir de un objeto GDI
'
' Parametros:
'
'   hGDIObject: El handle del objeto GDI.
'   ObjectType: El typo de objeto especificado en hGDIObject.
'         hPal: El handle a la paleta del objeto.
'
'-------------------------------------------------------------------------
Public Function HandleToPicture(ByVal hGDIObject As Long, _
                                ByVal ObjectType As PictureTypeConstants, _
                                Optional ByVal hPal As Long = 0) As StdPicture
Dim ipic As IPicture, picdes As PICTDESC, iidIPicture As IID
    
    ' Fill picture description
    
    picdes.cbSizeOfStruct = Len(picdes)
    picdes.picType = ObjectType
    picdes.hgdiObj = hGDIObject
    picdes.hPalOrXYExt = hPal
    
    ' IPictureDisp {7BF80981-BF32-101A-8BBB-00AA00300CAB}
    
    iidIPicture.Data1 = &H7BF80981
    iidIPicture.Data2 = &HBF32
    iidIPicture.Data3 = &H101A
    iidIPicture.Data4(0) = &H8B
    iidIPicture.Data4(1) = &HBB
    iidIPicture.Data4(2) = &H0
    iidIPicture.Data4(3) = &HAA
    iidIPicture.Data4(4) = &H0
    iidIPicture.Data4(5) = &H30
    iidIPicture.Data4(6) = &HC
    iidIPicture.Data4(7) = &HAB
    
    ' Create picture from bitmap handle
    
    OleCreatePictureIndirect picdes, iidIPicture, True, ipic
    ' Result will be valid Picture or Nothingeither way set it

    Set HandleToPicture = ipic
        
End Function
