VERSION 5.00
Begin VB.UserControl Line3DEx 
   CanGetFocus     =   0   'False
   ClientHeight    =   240
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   2370
   ClipControls    =   0   'False
   LockControls    =   -1  'True
   ScaleHeight     =   240
   ScaleWidth      =   2370
   Begin VB.Line Line1 
      BorderColor     =   &H8000000E&
      Index           =   1
      X1              =   90
      X2              =   1860
      Y1              =   90
      Y2              =   90
   End
   Begin VB.Line Line1 
      BorderColor     =   &H80000010&
      BorderWidth     =   2
      Index           =   0
      X1              =   120
      X2              =   1890
      Y1              =   90
      Y2              =   90
   End
End
Attribute VB_Name = "Line3DEx"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'------------------------------------------------------------------------------
' xShadowLine                                                       (29/Ago/98)
' Line3DEx Nuevo nombre y nuevas propiedades                        (16/Ene/99)
'
' Un control MUY simple para simular lneas sombreadas (3D)
'
'
' Guillermo 'guille' Som, 1998-2002
'------------------------------------------------------------------------------
Option Explicit

' Alineacin de la lnea (izquierda, centro, derecha)               (18/Ene/99)
Public Enum eL3DAlignment
    [Left Justify]
    [Right Justify]
    [Center]
    [None]
End Enum
Private m_Alignment As eL3DAlignment
' Porcentaje de ancho de las lneas en el contenedor                (18/Ene/99)
Private m_WidthPercent As Long
' Separacin desde la izquierda del borde del contenedor            (18/Ene/99)
' (este mismo valor se aplica a la derecha), el valor por defecto es 90
Private m_IndentValue As Long
' Si se ajusta automticamente al ancho del contenedor              (16/Ene/99)
Private m_AdjustWidth As Boolean

Private Sub UserControl_Initialize()
    m_AdjustWidth = False
    m_IndentValue = 0&
    m_WidthPercent = 0&
    m_Alignment = [None]
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    m_AdjustWidth = PropBag.ReadProperty("AdjustWidth", False)
    m_IndentValue = PropBag.ReadProperty("IndentValue", 0)
    m_WidthPercent = PropBag.ReadProperty("WidthPercent", 0)
    m_Alignment = PropBag.ReadProperty("Alignment", [None])
End Sub

Private Sub UserControl_Resize()
    Dim i As Long
    Static Estoy As Boolean
    
    If Not Estoy Then
        Estoy = True
        
        ' Si se debe ajustar automticamente al ancho del contenedor
        If m_AdjustWidth Then
            If TypeOf Extender.Parent Is Frame Then
                Extender.Left = 30
            Else
                Extender.Left = 0
            End If
            ' Si se especifica el valor de indentacin
            Extender.Left = Extender.Left + m_IndentValue
            Width = Extender.Parent.ScaleWidth - (Extender.Left * 2)
        Else
            ' Si se especifica el porcentaje
            If m_WidthPercent Then
                Width = Extender.Parent.ScaleWidth * m_WidthPercent \ 100
            End If
            ' Si se especifica la alineacin
            If m_Alignment = [Left Justify] Then
                Extender.Left = 0
            ElseIf m_Alignment = [Right Justify] Then
                Extender.Left = Extender.Parent.ScaleWidth - Width
            ElseIf m_Alignment = [Center] Then
                Extender.Left = (Extender.Parent.ScaleWidth - Width) \ 2
            End If
            
        End If
        
        ' Tamao del control
        If UserControl.Height <> 30 Then
            UserControl.Height = 30
        End If
        
        ' Posicionar las lineas
        For i = 0 To 1
            With Line1(i)
                .x1 = 0
                .X2 = UserControl.ScaleWidth
                .y1 = 15
                .Y2 = 15
            End With
        Next
        Estoy = False
    End If
End Sub

Public Property Get AdjustWidth() As Boolean
Attribute AdjustWidth.VB_Description = "Si se ajusta al ancho del contenedor, no se usa si est Alignment y/o WidthPercent"
    AdjustWidth = m_AdjustWidth
End Property

Public Property Let AdjustWidth(ByVal NewValue As Boolean)
    ' Si se ajusta automticamente al ancho del contenedor
    m_AdjustWidth = NewValue
    
    ' No usar las propiedades que no son compatibles
    m_Alignment = None
    m_WidthPercent = 0&
    
    UserControl_Resize
End Property

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    Call PropBag.WriteProperty("AdjustWidth", m_AdjustWidth, False)
    Call PropBag.WriteProperty("IndentValue", m_IndentValue, 0)
    Call PropBag.WriteProperty("WidthPercent", m_WidthPercent, 0)
    Call PropBag.WriteProperty("Alignment", m_Alignment, [None])
End Sub

Public Property Get IndentValue() As Long
Attribute IndentValue.VB_Description = "Valor de indentacin, slo se usa si AdjustWidth est asignado a True"
    IndentValue = m_IndentValue
End Property

Public Property Let IndentValue(ByVal NewValue As Long)
    ' Nuevo valor de indentacin
    m_IndentValue = NewValue
    
    ' No usar las propiedades que no son compatibles
    m_Alignment = None
    m_WidthPercent = 0&
    
    ' Reajustar el tamao de las lneas
    UserControl_Resize
End Property

Public Property Get WidthPercent() As Long
Attribute WidthPercent.VB_Description = "Porcentaje del ancho del contenedor, no compatible con AdjustWidth ni IndentValue"
    WidthPercent = m_WidthPercent
End Property

Public Property Let WidthPercent(ByVal NewValue As Long)
    ' Asignar el nuevo porcentaje de ventana
    ' Si es un valor no vlido, usar el 50%
    If NewValue < 0 Or NewValue > 100 Then
        NewValue = 50
    End If
    m_WidthPercent = NewValue
    ' Quitar los valores no compatibles
    m_AdjustWidth = False
    m_IndentValue = 0&
    UserControl_Resize
End Property

Public Property Get Alignment() As eL3DAlignment
Attribute Alignment.VB_Description = "Alineacin, no se usa con AlignWidth ni con IndentValue"
    Alignment = m_Alignment
End Property

Public Property Let Alignment(ByVal NewValue As eL3DAlignment)
    m_Alignment = NewValue
    
    ' Quitar los valores no compatibles
    m_AdjustWidth = False
    m_IndentValue = 0&
    
    UserControl_Resize
End Property

Public Sub Resize()
Attribute Resize.VB_Description = "Ajustar el tamao segn las propiedades"
    ' Redimensionar el control
    UserControl_Resize
End Sub
